#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include "list.h"
#include "gtkftpd.h"
#include "debug.h"
#include "conf_ban.h"
#include "conf_perm.h"
#include "conf_conf.h"
#include "conf.h"
#include "mesg_box.h"
#include "server.h"
#include "text.h"
#include "conf_win.h"


static void ok();
static void cancel();
static GtkWidget *get_main();
static gboolean switch_page(GtkNotebook *nb, GtkNotebookPage *page, gint page_index, gpointer data);
static void quitte_conf_boucle();

static GtkWidget *win=NULL;
int do_conf_boucle = 1;


void configure()
{
	GtkWidget *tbl, *btn_ok, *btn_can;

	win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(win), "Configure your ftp server");
	gtk_window_activate_focus(GTK_WINDOW(win));

	btn_ok = gtk_button_new_from_stock(GTK_STOCK_OK);
	btn_can = gtk_button_new_from_stock(GTK_STOCK_CANCEL);

	tbl = gtk_table_new(2, 2, FALSE);
	gtk_container_add(GTK_CONTAINER(win), tbl);
	gtk_table_attach(GTK_TABLE(tbl), get_main(), 0, 2, 0, 1, GTK_EXPAND | GTK_FILL, 5,
			GTK_EXPAND | GTK_FILL, 5);
	gtk_table_attach(GTK_TABLE(tbl), btn_ok, 0, 1, 1, 2, GTK_EXPAND, 0, 0, 5);
	gtk_table_attach(GTK_TABLE(tbl), btn_can, 1, 2, 1, 2, GTK_EXPAND, 0, 0, 5);

	g_signal_connect(G_OBJECT(win), "destroy", G_CALLBACK(quitte_conf_boucle), NULL);
	g_signal_connect(G_OBJECT(win), "delete_event", G_CALLBACK(quitte_conf_boucle), NULL);
	g_signal_connect(G_OBJECT(btn_ok), "clicked", G_CALLBACK(ok), NULL);
	g_signal_connect(G_OBJECT(btn_can), "clicked", G_CALLBACK(cancel), NULL);

	gtk_widget_show_all(win);

	while (do_conf_boucle)
	{
		if (!update_server())	break;
		while (gtk_events_pending())	{
			gtk_main_iteration();
			if (!do_conf_boucle)		break;
		}
	}

	if (win)
	{
		gtk_widget_destroy(win);
		win = NULL;
	}

	do_conf_boucle = 1;
}


static void quitte_conf_boucle()
{
	do_conf_boucle = 0;
}


static GtkWidget *get_main()
{
	GtkWidget *nb, *lbl_conf, *lbl_perm, *lbl_ban;

	nb = gtk_notebook_new();
	gtk_notebook_popup_enable(GTK_NOTEBOOK(nb));
	gtk_notebook_set_scrollable(GTK_NOTEBOOK(nb), FALSE);
	gtk_notebook_set_show_border(GTK_NOTEBOOK(nb), FALSE);
	g_signal_connect(nb, "switch_page", G_CALLBACK(switch_page), NULL);
	lbl_conf = gtk_label_new("Config");
	lbl_perm = gtk_label_new("Permissions");
	lbl_ban = gtk_label_new("Banned");
	gtk_notebook_append_page(GTK_NOTEBOOK(nb), get_conf(), lbl_conf);
	gtk_notebook_append_page(GTK_NOTEBOOK(nb), get_perm(), lbl_perm);
	gtk_notebook_append_page(GTK_NOTEBOOK(nb), get_ban(), lbl_ban);
	return(nb);
}



static gboolean switch_page(GtkNotebook *nb, GtkNotebookPage *page, gint page_index, gpointer data)
{
	return(TRUE);
}


static void ok()
{
	if (warning_message_box(GTK_WINDOW(get_conf_win()), "The server is going to restart, all the users will be disconnected. "
				"Do you still want to save your new settings ?"))
	{
		empty_conf(PERM_PART_BALISE);
		empty_conf(LIMITDIRECTORY_BALISE);
		save_conf();
		if ( ! save_perm() )
			return;
		save_ban();
		quitte_conf_boucle();

		//cancel();
		reinit();
		user_insert_sys_text((Tuser *)(g_slist_nth(list_user, 0))->data,
				"* The server has deconnected all the users because of the new configuration");
	} else
		quitte_conf_boucle();
}


static void cancel()
{
	quitte_conf_boucle();
	//if (win)
//		gtk_widget_destroy(win);
}


GtkWidget *get_conf_win()
{
	return(win);
}
