#include <gtk/gtk.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <getopt.h>
#include "gtkftpd.h"
#include "win.h"
#include "server.h"
#include "conf.h"
#include "menu.h"
#include "text.h"
#include "list.h"
#include "statusbar.h"
#include "debug.h"

#define PROG_VERSION "1.0.4"

int main(int argc, char **argv);
static gboolean init_window(gboolean win);
static void desinit_window();
static void assemble();
static void fin();
static void usage(const char *prog);
static void do_chroot(const char *path);
static void version(const char *prog);


static int do_main_boucle = 1;
static GtkWidget *tbl;



int main(int argc, char **argv)
{
	int optch;
	char *prog_path;
	int cmdx = 0;
	static char opt[] = "hc:v";
	static struct option lopts[] = {
		{ "help", 0, 0, 'h' },
		{ "chroot", 0, 0, 'c'},
		{ "version", 0, 0, 'v'},
		{ 0, 0, 0, 0 }
	};

	if (geteuid() != 0)
	{
		fprintf(stderr, "Need to be root !\n");
		return(0);
	}

	prog_path = argv[0];
	while ( (optch = getopt_long(argc, argv, opt, lopts, &cmdx)) != -1 )
		switch (optch)  {
				case 0:
						break;
				case 'h':
						usage(prog_path);
						return(0);
				case 'c':
						do_chroot(optarg);
						break;
				case 'v':
						version(prog_path);
						return(0);
				default:
						fprintf(stderr, "Use -h for help\n");
						return(0);
		}

	gtk_init(&argc, &argv);
	if ( !init_conf() || !init_window(TRUE)  || !init_server() )
	{
		fin();
		return(0);
	}

	while (do_main_boucle)
	{
		if (!update_server())		break;
		while (gtk_events_pending())	{
			gtk_main_iteration();
			if (!do_main_boucle)		break;
		}
	}

	fin();
	return(0);
}


static gboolean init_window(gboolean win)
{
	if (win)
		if (!init_win())
			return(FALSE);
	if ( !init_menu() || !init_text() || !init_list() || !init_statusbar() )
		return(FALSE);
		
	init_user("All", NULL);
	/*init_user("Simon", NULL); init_user(NULL, NULL);
  user_insert_text((Tuser *) (g_slist_nth(list_user, 2))->data, "ceci est un test", LARGE_TAG);
  user_insert_text((Tuser *) (g_slist_nth(list_user, 3))->data, "ceci est un test", LARGE_TAG);
  user_insert_text((Tuser *) (g_slist_nth(list_user, 3))->data, "ceci est un test", LARGE_TAG);*/
	//desinit_user( (Tuser *) (g_slist_nth(list_user, 3))->data );				// DEBUG
	//init_user("simon", NULL);
	assemble();

	return(TRUE);
}


static void desinit_window()
{
	desinit_statusbar();
	desinit_list();
	desinit_text();
	desinit_menu();
	desinit_win();
}


static void fin()
{
	desinit_server();
	desinit_window();
	desinit_conf();
}


static void assemble()
{
	tbl = gtk_table_new(3, 2, FALSE);
	gtk_container_add(GTK_CONTAINER(get_win()), tbl);

	gtk_table_attach(GTK_TABLE(tbl), get_menu(), 0, 2, 0, 1, GTK_EXPAND | GTK_FILL, 0, 0, 0);
	gtk_table_attach(GTK_TABLE(tbl), get_text(), 0, 1, 1, 2, GTK_EXPAND | GTK_FILL,
									 GTK_EXPAND | GTK_FILL, 3, 5);
	gtk_table_attach(GTK_TABLE(tbl), get_list(), 1, 2, 1, 2, GTK_FILL, GTK_EXPAND | GTK_FILL, 3, 5);
	gtk_table_attach(GTK_TABLE(tbl), get_statusbar(), 0, 2, 2, 3, GTK_EXPAND | GTK_FILL, 0, 0, 0);

	gtk_widget_show_all(get_win());
}


void quitte_main_boucle()
{
	do_main_boucle = 0;
}


static void usage(const char *prog)
{
	//fprintf(stderr, "Usage: %s [-h] [-D]\n", prog);
	fprintf(stderr, "Usage: %s [-h]\n", prog);
	fputs("\t-h\tPrint this help\n", stderr);
//	fputs("\t-D\tdaemon mode\n", stderr);
}


static void do_chroot(const char *path)
{
	TRACE;
}


static void version(const char *prog)
{
	fputs("Version: " PROG_VERSION "\n", stderr);
	usage(prog);
}


void reinit()
{
	desinit_users();
	desinit_server();
	desinit_window();
	gtk_widget_destroy(tbl);
	tbl = NULL;
	init_window(FALSE);
	init_server();
}
