#include <gtk/gtk.h>
#include <stdlib.h>
#include "menu.h"
#include "win.h"
#include "debug.h"
#include "gtkftpd.h"
#include "conf_win.h"

#define TEXT_APROPOS "GtkFtpd-1.0.0 under GPL\nkendo@tuxfamily.org"
#define TITLE_APROPOS "A propos..."

#define EXPORT 1
#define PRINT 2
#define EXIT 3

#define CUT 4
#define COPY 5
#define PAST 6
#define FIND 7
#define NEXT 8
#define PREVIOUS 9
#define CONFIGURE 10

#define APROPOS 11

static GtkWidget *menu=NULL;

//static void m_next();
//static void m_find();
static void m_apropos();
//static void m_previous();
//static void m_configure();
static void evtMenu(GtkWidget *w, guint op);


static GtkItemFactoryEntry entriesMenu[] =
	{
		{"/_File", NULL, NULL, 0, "<Branch>"},
		{"/File/_Exit", "<F4>", evtMenu, EXIT, "<Item>"},
		{"/_Edit", NULL, NULL, 0, "<Branch>"},
/*		{"/Edit/_Find", "<control>F", evtMenu, FIND, "<Item>"},
		{"/Edit/_Next", "<f3>", evtMenu, NEXT, "<Item>"},
		{"/Edit/_Previous", "<f4>", evtMenu, PREVIOUS, "<Item>"},
		{"/Edit/", NULL, NULL, 0, "<Separator>"},*/
		{"/Edit/Co_nfigure", "<control>M", evtMenu, CONFIGURE, "<Item>"},
		{"/_Help", NULL, NULL, 0, "<LastBranch>"},
		{"/Help/_A propos...", "<control>A", evtMenu, APROPOS, "<Item>"}
	};


static void evtMenu(GtkWidget *w, guint op)
{
	switch(op)
		{
			case EXIT:			quitte_main_boucle(); break;
			/*case FIND:			m_find(); break;
			case NEXT:			m_next(); break;
			case PREVIOUS:	m_previous(); break;*/
			case CONFIGURE:	configure(); break;
			case APROPOS:		m_apropos(); break;
		}
}


static guint nbEntries = sizeof(entriesMenu)/sizeof(GtkItemFactoryEntry);


gboolean init_menu()
{
	GtkItemFactory *menuItem;
	GtkAccelGroup *shortcut;

	shortcut = gtk_accel_group_new();
	menuItem = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<Main>", shortcut);
	gtk_item_factory_create_items(menuItem, nbEntries, entriesMenu, NULL);
	gtk_window_add_accel_group(GTK_WINDOW(get_win()), shortcut);

	menu = gtk_item_factory_get_widget(menuItem, "<Main>");
	
	return(TRUE);
}


void desinit_menu()
{
	if (menu)
		gtk_widget_destroy(menu);
}


GtkWidget *get_menu()
{
	return(menu);
}


/*static void m_find()
{
}

static void m_next()
{
}

static void m_previous()
{
}*/

static void m_apropos()
{
	GtkWidget *db, *lbl;

	db = gtk_dialog_new_with_buttons(TITLE_APROPOS, GTK_WINDOW(get_win()), 
			GTK_DIALOG_DESTROY_WITH_PARENT, GTK_STOCK_OK, GTK_RESPONSE_NONE, NULL);
	lbl = gtk_label_new(TEXT_APROPOS);
	g_signal_connect_swapped(GTK_OBJECT(db), "response", G_CALLBACK(gtk_widget_destroy), GTK_OBJECT(db));
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(db)->vbox), lbl);
	gtk_widget_show_all(db);
}
