#include <gtk/gtk.h>
#include <string.h>
#include "mesg_box.h"
#include "debug.h"


void error_message_box(GtkWindow *win, const char *msg)
{
	GtkWidget *dlg;

	dlg = gtk_message_dialog_new(win, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR,
			GTK_BUTTONS_OK, msg);
	gtk_dialog_run(GTK_DIALOG(dlg));
	gtk_widget_destroy(dlg);
}


gboolean warning_message_box(GtkWindow *win, const char *str)
{
	GtkWidget *dlg;
	unsigned int rep;

	dlg = gtk_message_dialog_new(win, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING,
			GTK_BUTTONS_OK_CANCEL, str);
	rep = gtk_dialog_run(GTK_DIALOG(dlg));
	gtk_widget_destroy(dlg);
	if (rep==GTK_RESPONSE_OK)
		return(TRUE);
	else
		return(FALSE);
}


void info_message_box(GtkWindow *win, const char *str)
{
	GtkWidget *dlg;

	dlg = gtk_message_dialog_new(win, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_INFO,
			GTK_BUTTONS_OK, str);
	gtk_dialog_run(GTK_DIALOG(dlg));
	gtk_widget_destroy(dlg);
}	


char *get_entry_dbox(GtkWindow *win, const char *title, const char *label)
{
	GtkWidget *dlg, *lbl, *entry, *tbl;
	char *ret;
	gint rep;
	
	tbl = gtk_table_new(2, 0, FALSE);
	dlg = gtk_dialog_new_with_buttons(title, win, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_STOCK_OK,
			GTK_RESPONSE_OK, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);
	lbl = gtk_label_new_with_mnemonic(label);
	entry = gtk_entry_new();
	gtk_label_set_mnemonic_widget(GTK_LABEL(lbl), entry);

	gtk_table_attach(GTK_TABLE(tbl), lbl, 0, 1, 0, 1, GTK_EXPAND, 0, GTK_EXPAND, 0);
	gtk_table_attach(GTK_TABLE(tbl), entry, 1, 2, 0, 1, GTK_EXPAND | GTK_FILL, 0, GTK_EXPAND, 0);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dlg)->vbox), tbl);

	gtk_widget_show_all(tbl);
	rep = gtk_dialog_run(GTK_DIALOG(dlg));

	if (rep==GTK_RESPONSE_OK)
		ret = strdup((char *) gtk_entry_get_text(GTK_ENTRY(entry)));
	else
		ret = NULL;
	gtk_widget_destroy(dlg);
	return(ret);
}
