#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <string.h>
#include "user.h"
#include "conf.h"
#include "s_req.h"
#include "debug.h"


static gboolean server_conf_allow(const Tuser *user, const char *path, const int req);

char *is_allowed(const Tuser *user, char *path, const int req)
{
	char *real_path;

	real_path = (char *) malloc(MAXPATHLEN);
	memset(real_path, 0, MAXPATHLEN);
	if ( !realpath(path, real_path) )
		return(NULL);
	if ( strncmp(real_path, user->rezo->path->root, strlen(user->rezo->path->root)) )
		return(NULL);
	if (!server_conf_allow(user, real_path, req))
		return(NULL);
	free(path);
	return(real_path);
}


static gboolean server_conf_allow(const Tuser *user, const char *path, const int req)
{
	char *balise;
	char **perm;
	int i=-1;

	balise = malloc(strlen(user->rezo->login)+strlen(PERM_PART_BALISE)+strlen(path)+1);
	memset(balise, 0, strlen(user->rezo->login)+strlen(PERM_PART_BALISE)+strlen(path)+1);
	strncpy(balise, user->rezo->login, strlen(user->rezo->login));
	strncat(balise, PERM_PART_BALISE, strlen(PERM_PART_BALISE));
	strncat(balise, path, strlen(path));
	perm = get_settings(balise);
	if (perm)
	{
		while (perm[++i])
			if ( !strncmp(perm[i], request[req], strlen(request[req])) )
				return(FALSE);
	}
	return(TRUE);
}


gboolean is_banned(struct in_addr *sin_addr)
{
	unsigned char *ip_tmp;
	int ip[4];
	char ip_str[16];
	char **ip_ban;
	int i;
	
	ip_tmp = (unsigned char *) sin_addr;
	memset(ip, 0, 4);
	memset(ip_str, 0, 16);
	for (i=0;i<4;i++)
		ip[i] = *ip_tmp++;
	sprintf(ip_str, "%d.%d.%d.%d", ip[0], ip[1], ip[2], ip[3]);

	ip_ban = get_settings(BAN_BALISE);
	i=-1;
	if (ip_ban)
	{
		while (ip_ban[++i])
			if ( !strncmp(ip_ban[i], ip_str, strlen(ip_ban[i])) )
				return (TRUE);
	}

	return (FALSE);
}
