
#ifndef __USER_H__
#define __USER_H__

#include <gtk/gtk.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <stdio.h>
#include <pthread.h>


typedef struct _Tuser_text Tuser_text;
typedef struct _Tuser_list Tuser_list;
typedef struct _Tuser_nt Tuser_nt;
typedef struct _Tuser_path Tuser_path;
typedef struct _Tuser_port Tuser_port;
typedef struct _Tuser_pasv Tuser_pasv;
typedef struct _Tuser Tuser;

struct _Tuser_text {
	GtkWidget *text;
	GtkWidget *sw;
  GtkTextBuffer *buffer;
	int nbpage;
	gboolean color;
};

struct _Tuser_list {
	GtkTreeIter iter;
	gboolean selected;
};

/* 
 * current commence toujours par '/'
 * root ne finit jamais par '/'
 */
struct _Tuser_path {
	char *root;
	char *current;
};

struct _Tuser_port {
	int ip[4];
	unsigned short int port;
	int sock;
};

struct _Tuser_pasv {
	int sock;
	struct sockaddr_in addr;
	unsigned short int port;
};

struct _Tuser_nt {
	pthread_t thread;
	int sock;
	int ip[4];
	char *login;
	int rest;
	gboolean auth;
	gboolean anonymous;
	struct sockaddr_in *addr;
	struct timeval lastop;
	Tuser_path *path;
	Tuser_port *port;
	Tuser_pasv *pasv;
};

struct _Tuser {
	int id;
	Tuser_text *text;
	Tuser_list *list;
	Tuser_nt *rezo;
	gchar *name;
};

#endif
