#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include "win.h"
#include "conf.h"
#include "debug.h"
#include "gtkftpd.h"


static GtkWidget *win;

gboolean init_win()
{
	GdkPixbuf *icon=NULL;
	gchar *icon_path;

	win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(win), "gtkftpd - un serveur ftpd convivial !");
	gtk_window_activate_focus(GTK_WINDOW(win));
	icon_path = get_setting(ICON_BALISE);
	if (icon_path)
	{
		icon = gdk_pixbuf_new_from_file(icon_path, NULL);
		free(icon_path);
		gtk_window_set_icon(GTK_WINDOW(win), icon);
	} else	{
#ifdef DEBUG
		fprintf(stderr, "Error: can't create icon from file.\n");
#endif
	}
	/*if (!icon)
	{
		perror("loading icon");
		quitte_main_boucle();
		return(FALSE);
	}*/
	gtk_window_set_position(GTK_WINDOW(win), GTK_WIN_POS_CENTER_ALWAYS);
	if ( !get_setting(HEIGHT_BALISE) || !get_setting(WIDTH_BALISE)  ||
			 !get_setting(XPOS_BALISE)	 || !get_setting(YPOS_BALISE) )
	{
#ifdef DEBUG
		fprintf(stderr, "Error: can't find balise width, height, xpos and/or ypos in config file\n");
#endif
		quitte_main_boucle();
		return(FALSE);
	}
	gtk_window_resize( GTK_WINDOW(win), atoi(get_setting(WIDTH_BALISE)),
										 atoi(get_setting(HEIGHT_BALISE)) );
	gtk_window_move( GTK_WINDOW(win), atoi(get_setting(XPOS_BALISE)),
									 atoi(get_setting(YPOS_BALISE)) );

	gtk_signal_connect(GTK_OBJECT(win), "delete_event", GTK_SIGNAL_FUNC(quitte_main_boucle), NULL);
	gtk_signal_connect(GTK_OBJECT(win), "destroy", GTK_SIGNAL_FUNC(quitte_main_boucle), NULL);
	return(TRUE);
}


void desinit_win()
{
	int width, height, xpos, ypos;

	gtk_window_get_size(GTK_WINDOW(win), &width, &height);
	put_setting_int(HEIGHT_BALISE, height);
	put_setting_int(WIDTH_BALISE, width);
	gtk_window_get_position(GTK_WINDOW(win), &xpos, &ypos);
	put_setting_int(XPOS_BALISE, xpos);
	put_setting_int(YPOS_BALISE, ypos);
}


GtkWidget *get_win()
{
	return(win);
}
